/*  free_neuron_array.c */

/* 	Copyright 2004 Oswaldo Morizaki */

/* 	This file is part of ga-nn-ag.

    ga-nn-ag is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ga-nn-ag is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ga-nn; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "my_header.h"
#include "aux_prot.h"

/***** Free memory neuron_array *****/
void * free_neuron_array(int num_neuron, struct neuron ** neuron_array)
{
	int k;
	for (k=0; k< num_neuron; k++)
	{
		if ( !(neuron_array[k]->con_x == NULL) )
		{
			free(neuron_array[k]->con_x);
			free(neuron_array[k]->con_y);	
			free(neuron_array[k]->con_w);
			free(neuron_array[k]->age);
			if (neuron_array[k]->momentum == 1)
			{
				free(neuron_array[k]->delta_con_w);	
				neuron_array[k]->delta_con_w = NULL;
			}
			
			neuron_array[k]->con_w = NULL;
			neuron_array[k]->con_y = NULL;
			neuron_array[k]->con_x = NULL;
			neuron_array[k]->age = NULL;
		}
		
		free(neuron_array[k]);
		neuron_array[k] = NULL;
	}	
	free(neuron_array);
	neuron_array=NULL;
	return(neuron_array);
}

